/**
 * Copyright (c) 2013-2017 Lorenzo Bettini.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Lorenzo Bettini - Initial contribution and API
 */
package org.eclipse.xsemantics.dsl.ide;

import com.google.inject.Guice;
import com.google.inject.Injector;
import org.eclipse.xsemantics.dsl.XsemanticsRuntimeModule;
import org.eclipse.xsemantics.dsl.XsemanticsStandaloneSetup;
import org.eclipse.xsemantics.dsl.ide.XsemanticsIdeModule;
import org.eclipse.xtext.util.Modules2;

/**
 * Initialization support for running Xtext languages as language servers.
 */
@SuppressWarnings("all")
public class XsemanticsIdeSetup extends XsemanticsStandaloneSetup {
  @Override
  public Injector createInjector() {
    XsemanticsRuntimeModule _xsemanticsRuntimeModule = new XsemanticsRuntimeModule();
    XsemanticsIdeModule _xsemanticsIdeModule = new XsemanticsIdeModule();
    return Guice.createInjector(Modules2.mixin(_xsemanticsRuntimeModule, _xsemanticsIdeModule));
  }
}
