/**
 */
package org.eclipse.xsemantics.dsl.xsemantics.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.xsemantics.dsl.xsemantics.JudgmentDescription;
import org.eclipse.xsemantics.dsl.xsemantics.ReferToJudgment;
import org.eclipse.xsemantics.dsl.xsemantics.Rule;
import org.eclipse.xsemantics.dsl.xsemantics.RuleConclusion;
import org.eclipse.xsemantics.dsl.xsemantics.RuleParameter;
import org.eclipse.xsemantics.dsl.xsemantics.XsemanticsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.xsemantics.dsl.xsemantics.impl.RuleImpl#get_judgment <em>judgment</em>}</li>
 *   <li>{@link org.eclipse.xsemantics.dsl.xsemantics.impl.RuleImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.xsemantics.dsl.xsemantics.impl.RuleImpl#getConclusion <em>Conclusion</em>}</li>
 *   <li>{@link org.eclipse.xsemantics.dsl.xsemantics.impl.RuleImpl#get_inputParams <em>input Params</em>}</li>
 *   <li>{@link org.eclipse.xsemantics.dsl.xsemantics.impl.RuleImpl#get_outputParams <em>output Params</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RuleImpl extends OverriderImpl implements Rule
{
	/**
	 * The cached value of the '{@link #get_judgment() <em>judgment</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #get_judgment()
	 * @generated
	 * @ordered
	 */
	protected JudgmentDescription _judgment;

	/**
	 * This is true if the judgment reference has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean _judgmentESet;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getConclusion() <em>Conclusion</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConclusion()
	 * @generated
	 * @ordered
	 */
	protected RuleConclusion conclusion;

	/**
	 * The cached value of the '{@link #get_inputParams() <em>input Params</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #get_inputParams()
	 * @generated
	 * @ordered
	 */
	protected EList<RuleParameter> _inputParams;

	/**
	 * The cached value of the '{@link #get_outputParams() <em>output Params</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #get_outputParams()
	 * @generated
	 * @ordered
	 */
	protected EList<RuleParameter> _outputParams;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RuleImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return XsemanticsPackage.Literals.RULE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JudgmentDescription get_judgment()
	{
		if (_judgment != null && _judgment.eIsProxy())
		{
			InternalEObject old_judgment = (InternalEObject)_judgment;
			_judgment = (JudgmentDescription)eResolveProxy(old_judgment);
			if (_judgment != old_judgment)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, XsemanticsPackage.RULE__JUDGMENT, old_judgment, _judgment));
			}
		}
		return _judgment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JudgmentDescription basicGet_judgment()
	{
		return _judgment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void set_judgment(JudgmentDescription new_judgment)
	{
		JudgmentDescription old_judgment = _judgment;
		_judgment = new_judgment;
		boolean old_judgmentESet = _judgmentESet;
		_judgmentESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, XsemanticsPackage.RULE__JUDGMENT, old_judgment, _judgment, !old_judgmentESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unset_judgment()
	{
		JudgmentDescription old_judgment = _judgment;
		boolean old_judgmentESet = _judgmentESet;
		_judgment = null;
		_judgmentESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, XsemanticsPackage.RULE__JUDGMENT, old_judgment, null, old_judgmentESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSet_judgment()
	{
		return _judgmentESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName)
	{
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, XsemanticsPackage.RULE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RuleConclusion getConclusion()
	{
		return conclusion;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetConclusion(RuleConclusion newConclusion, NotificationChain msgs)
	{
		RuleConclusion oldConclusion = conclusion;
		conclusion = newConclusion;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, XsemanticsPackage.RULE__CONCLUSION, oldConclusion, newConclusion);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConclusion(RuleConclusion newConclusion)
	{
		if (newConclusion != conclusion)
		{
			NotificationChain msgs = null;
			if (conclusion != null)
				msgs = ((InternalEObject)conclusion).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - XsemanticsPackage.RULE__CONCLUSION, null, msgs);
			if (newConclusion != null)
				msgs = ((InternalEObject)newConclusion).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - XsemanticsPackage.RULE__CONCLUSION, null, msgs);
			msgs = basicSetConclusion(newConclusion, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, XsemanticsPackage.RULE__CONCLUSION, newConclusion, newConclusion));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RuleParameter> get_inputParams()
	{
		if (_inputParams == null)
		{
			_inputParams = new EObjectResolvingEList.Unsettable<RuleParameter>(RuleParameter.class, this, XsemanticsPackage.RULE__INPUT_PARAMS);
		}
		return _inputParams;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unset_inputParams()
	{
		if (_inputParams != null) ((InternalEList.Unsettable<?>)_inputParams).unset();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSet_inputParams()
	{
		return _inputParams != null && ((InternalEList.Unsettable<?>)_inputParams).isSet();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RuleParameter> get_outputParams()
	{
		if (_outputParams == null)
		{
			_outputParams = new EObjectResolvingEList.Unsettable<RuleParameter>(RuleParameter.class, this, XsemanticsPackage.RULE__OUTPUT_PARAMS);
		}
		return _outputParams;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unset_outputParams()
	{
		if (_outputParams != null) ((InternalEList.Unsettable<?>)_outputParams).unset();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSet_outputParams()
	{
		return _outputParams != null && ((InternalEList.Unsettable<?>)_outputParams).isSet();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getJudgmentSymbol()
	{
		RuleConclusion _conclusion = this.getConclusion();
		return _conclusion.getJudgmentSymbol();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getRelationSymbols()
	{
		RuleConclusion _conclusion = this.getConclusion();
		return _conclusion.getRelationSymbols();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case XsemanticsPackage.RULE__CONCLUSION:
				return basicSetConclusion(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
			case XsemanticsPackage.RULE__JUDGMENT:
				if (resolve) return get_judgment();
				return basicGet_judgment();
			case XsemanticsPackage.RULE__NAME:
				return getName();
			case XsemanticsPackage.RULE__CONCLUSION:
				return getConclusion();
			case XsemanticsPackage.RULE__INPUT_PARAMS:
				return get_inputParams();
			case XsemanticsPackage.RULE__OUTPUT_PARAMS:
				return get_outputParams();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID)
		{
			case XsemanticsPackage.RULE__JUDGMENT:
				set_judgment((JudgmentDescription)newValue);
				return;
			case XsemanticsPackage.RULE__NAME:
				setName((String)newValue);
				return;
			case XsemanticsPackage.RULE__CONCLUSION:
				setConclusion((RuleConclusion)newValue);
				return;
			case XsemanticsPackage.RULE__INPUT_PARAMS:
				get_inputParams().clear();
				get_inputParams().addAll((Collection<? extends RuleParameter>)newValue);
				return;
			case XsemanticsPackage.RULE__OUTPUT_PARAMS:
				get_outputParams().clear();
				get_outputParams().addAll((Collection<? extends RuleParameter>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID)
		{
			case XsemanticsPackage.RULE__JUDGMENT:
				unset_judgment();
				return;
			case XsemanticsPackage.RULE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case XsemanticsPackage.RULE__CONCLUSION:
				setConclusion((RuleConclusion)null);
				return;
			case XsemanticsPackage.RULE__INPUT_PARAMS:
				unset_inputParams();
				return;
			case XsemanticsPackage.RULE__OUTPUT_PARAMS:
				unset_outputParams();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID)
		{
			case XsemanticsPackage.RULE__JUDGMENT:
				return isSet_judgment();
			case XsemanticsPackage.RULE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case XsemanticsPackage.RULE__CONCLUSION:
				return conclusion != null;
			case XsemanticsPackage.RULE__INPUT_PARAMS:
				return isSet_inputParams();
			case XsemanticsPackage.RULE__OUTPUT_PARAMS:
				return isSet_outputParams();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
	{
		if (baseClass == ReferToJudgment.class)
		{
			switch (derivedFeatureID)
			{
				case XsemanticsPackage.RULE__JUDGMENT: return XsemanticsPackage.REFER_TO_JUDGMENT__JUDGMENT;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
	{
		if (baseClass == ReferToJudgment.class)
		{
			switch (baseFeatureID)
			{
				case XsemanticsPackage.REFER_TO_JUDGMENT__JUDGMENT: return XsemanticsPackage.RULE__JUDGMENT;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString()
	{
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //RuleImpl
